<template>
  <div 
    v-if="props.selectedDataPoint"
    class="bg-[#2B0A17] rounded-lg text-white w-64 overflow-hidden shadow-lg"
  >
    <!-- Header -->
    <div class="flex justify-between items-center bg-[#4A0D2C] px-4 py-2">
      <div class="flex items-center">
        <span class="text-sm font-normal opacity-80">Report: {{ props.selectedDataPoint?.id?.substring(0,15) }}</span>
      </div>
      <button @click="closePanel" class="text-lg hover:text-gray-300">×</button>
    </div>
    <!-- Details Grid -->
    <br>
    <div class="px-4 pb-4 space-y-4">
      <div class="flex flex-col">
        <span class="text-sm text-gray-400">Predicted Time:</span>
        <span class="text-sm">{{ props.selectedDataPoint?.arguments?.timestamp }}</span>
      </div>
      <div class="flex flex-col">
        <span class="text-sm text-gray-400">Source:</span>
        <span class="text-sm">{{ props.selectedDataPoint?.arguments?.source }}</span>
      </div>
      <div class="flex flex-col">
        <span class="text-sm text-gray-400">Predicted Time:</span>
        <span class="text-sm">{{ props.selectedDataPoint?.arguments?.predictedTime }}</span>
      </div>
      <div class="flex flex-col">
        <span class="text-sm text-gray-400">Storm Details:</span>
        <div class="text-sm">
          <div>Category: {{ formatCategory(props.selectedDataPoint?.arguments?.category) }}</div>
          <div>Max Wind Speed: {{ props.selectedDataPoint?.arguments?.maxWindSpeed }} mph</div>
          <div>Population in >= Cat 1: {{ formatPopulation(props.selectedDataPoint?.arguments?.populationInCat) }}</div>
          <div>Population at Risk: {{ formatPopulation(props.selectedDataPoint?.arguments?.populationAtRisk) }}</div>
          <div>Number of countries involved: {{ props.selectedDataPoint?.arguments?.countries }}</div>
        </div>
      </div>
      <div class="flex flex-col">
        <span class="text-sm text-gray-400">Location:</span>
        <div class="text-sm">
          <div>Lat: {{ formatCoordinate(props.selectedDataPoint?.lat) }}°</div>
          <div>Lng: {{ formatCoordinate(props.selectedDataPoint?.lng) }}°</div>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { ref } from 'vue'
import { useEventBus } from '@/components/UI/eventBus'
import type { DRMData } from '@/types/drm'

const props = defineProps<{
  selectedDataPoint: DRMData | null
}>()

const emit = defineEmits(['close'])

const closePanel = () => {
  emit('close')
}

const formatCoordinate = (coord: number | undefined): string => {
  return coord?.toFixed(4) ?? 'N/A'
}

const formatCategory = (category: number | undefined): string => {
  if (category === undefined) return 'N/A'
  return `Category ${category}`
}

const formatPopulation = (population: number | undefined): string => {
  if (population === undefined) return 'N/A'
  return population.toLocaleString()
}
</script>

<style scoped>
.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.3s ease;
}

.fade-enter-from,
.fade-leave-to {
  opacity: 0;
}
</style>
